'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = Icon;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultStyle = {
  border: '1px solid #1fc8db',
  borderRight: 0,
  borderTop: 0,
  display: 'block',
  height: '6px',
  width: '6px'
};

function Icon(props) {
  var deg = props.direction === 'top' ? 135 : -45;
  var style = _extends({}, defaultStyle, {
    WebkitTransform: 'rotate(' + deg + 'deg)',
    transform: 'rotate(' + deg + 'deg)'
  });
  return _react2.default.createElement(
    'div',
    {
      onClick: props.onClick,
      style: _extends({ padding: '5px', width: '8px', cursor: 'pointer' }, props.style)
    },
    _react2.default.createElement('div', { style: _extends({}, style, { borderColor: props.color }) })
  );
}

Icon.propTypes = {
  style: _react.PropTypes.object,
  color: _react.PropTypes.string,
  direction: _react.PropTypes.oneOf(['top', 'bottom']),
  onClick: _react.PropTypes.func
};