'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _shallowEquals = require('./shallow-equals');

var _shallowEquals2 = _interopRequireDefault(_shallowEquals);

var _sortIcon = require('./sort-icon');

var _sortIcon2 = _interopRequireDefault(_sortIcon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RebulmaSortableTable = function (_Component) {
  _inherits(RebulmaSortableTable, _Component);

  function RebulmaSortableTable(props) {
    _classCallCheck(this, RebulmaSortableTable);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(RebulmaSortableTable).call(this, props));

    var _props$defaultSort = props.defaultSort;
    var key = _props$defaultSort.key;
    var type = _props$defaultSort.type;

    _this.state = {
      data: _this.sortData(props.data, key, type),
      sort: { key: key, type: type },
      hoverd: null
    };
    return _this;
  }

  _createClass(RebulmaSortableTable, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _state$sort = this.state.sort;
      var key = _state$sort.key;
      var type = _state$sort.type;

      this.setState({ data: this.sortData(nextProps.data, key, type) });
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !(0, _shallowEquals2.default)(nextProps, this.props) || !(0, _shallowEquals2.default)(nextState, this.state);
    }
  }, {
    key: 'compare',
    value: function compare(a, b) {
      var ax = [];
      var bx = [];
      String(a).replace(/(\d+)|(\D+)/g, function (_, $1, $2) {
        return ax.push([$1 || Infinity, $2 || '']);
      });
      String(b).replace(/(\d+)|(\D+)/g, function (_, $1, $2) {
        return bx.push([$1 || Infinity, $2 || '']);
      });
      while (ax.length && bx.length) {
        var an = ax.shift();
        var bn = bx.shift();
        var nn = an[0] - bn[0] || an[1].localeCompare(bn[1]);
        if (nn) return nn;
      }
      return ax.length - bx.length;
    }
  }, {
    key: 'sortData',
    value: function sortData(data, key) {
      var _this2 = this;

      var type = arguments.length <= 2 || arguments[2] === undefined ? 'asc' : arguments[2];

      return data.sort(function (a, b) {
        var column = _this2.props.columns.filter(function (c) {
          return c.key === key;
        })[0];
        if (type === 'asc') {
          if (column && column.ascSorter) return column.ascSorter(a[key], b[key]);
          return _this2.compare(a[key], b[key]);
        }
        if (type === 'desc') {
          if (column && column.descSorter) return column.descSorter(a[key], b[key]);
          return _this2.compare(b[key], a[key]);
        }
        throw new Error('Unkown sort type [${type}], sort type is one of [\'desc\', \'asc\'].');
      });
    }
  }, {
    key: 'sort',
    value: function sort(key, type) {
      if (key === this.sort.key && type === this.sort.type) return;
      this.setState({
        data: this.sortData(this.state.data, key, type),
        sort: { key: key, type: type }
      });
    }
  }, {
    key: 'renderIcon',
    value: function renderIcon(key) {
      var _this3 = this;

      var onClick = function onClick(type) {
        return _this3.sort(key, type);
      };
      var sort = this.state.sort;

      var disableDesc = key === sort.key && sort.type === 'desc';
      var disableAsc = key === sort.key && sort.type === 'asc';
      return _react2.default.createElement(
        'div',
        { style: _extends({}, _styles2.default.icon, this.props.styles.icon) },
        _react2.default.createElement(_sortIcon2.default, {
          onClick: onClick,
          disableAsc: disableAsc,
          disableDesc: disableDesc,
          enabledColor: this.props.enabledIconColor,
          disableColor: this.props.disabledIconColor
        })
      );
    }
  }, {
    key: 'renderHeader',
    value: function renderHeader() {
      var _this4 = this;

      return this.props.columns.map(function (c) {
        var style = _extends({}, _styles2.default.th, _this4.props.styles.th, c.columnStyle, c.props && c.props.style);
        if (_this4.props.isBordered) style.borderWidth = '1px';
        return _react2.default.createElement(
          'th',
          _extends({}, c.props, {
            style: style,
            key: c.key
          }),
          _react2.default.createElement(
            'div',
            null,
            c.name,
            c.sortable === false ? null : _this4.renderIcon(c.key)
          )
        );
      });
    }
  }, {
    key: 'renderData',
    value: function renderData(d) {
      var _this5 = this;

      return this.props.columns.map(function (c) {
        var style = _extends({}, _styles2.default.td, _this5.props.styles.td, c.columnStyle, d.props && d.props.style);
        if (_this5.props.isBordered) style.borderWidth = '1px';
        return _react2.default.createElement(
          'td',
          _extends({}, d.props, {
            style: style,
            key: c.key
          }),
          d[c.key]
        );
      });
    }
  }, {
    key: 'renderRow',
    value: function renderRow() {
      var _this6 = this;

      return this.state.data.map(function (d, i) {
        var style = _extends({}, i % 2 === 0 ? _styles2.default.evenColor : _styles2.default.oddColor, _this6.state.hoverd === i ? _styles2.default.hoverColor : {});
        var onEnter = function onEnter() {
          return _this6.setState({ hoverd: i });
        };
        var onLeave = function onLeave() {
          return _this6.setState({ hoverd: null });
        };
        return _react2.default.createElement(
          'tr',
          {
            key: i,
            style: style,
            onMouseEnter: onEnter,
            onMouseLeave: onLeave
          },
          _this6.renderData(d)
        );
      });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'table',
        {
          style: _extends({}, _styles2.default.table, this.props.styles.table),
          className: this.props.className
        },
        _react2.default.createElement(
          'thead',
          null,
          _react2.default.createElement(
            'tr',
            null,
            this.renderHeader()
          )
        ),
        _react2.default.createElement(
          'tbody',
          null,
          this.renderRow()
        )
      );
    }
  }]);

  return RebulmaSortableTable;
}(_react.Component);

RebulmaSortableTable.propTypes = {
  data: _react.PropTypes.array.isRequired,
  columns: _react.PropTypes.array.isRequired,
  enabledIconColor: _react.PropTypes.string,
  disabledIconColor: _react.PropTypes.string,
  isBordered: _react.PropTypes.bool,
  isStriped: _react.PropTypes.bool,
  className: _react.PropTypes.string,
  defaultSort: _react.PropTypes.shape({
    key: _react.PropTypes.string.isRequired,
    type: _react.PropTypes.string.isRequired
  }),
  styles: _react.PropTypes.object
};
RebulmaSortableTable.defaultProps = {
  enabledIconColor: '#1fc8db',
  disabledIconColor: '#f5f7fa',
  defaultSort: {
    key: '',
    type: 'asc'
  },
  styles: {}
};
exports.default = RebulmaSortableTable;