'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = SortIcon;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _arrowIcon = require('./arrow-icon');

var _arrowIcon2 = _interopRequireDefault(_arrowIcon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  wrapper: {
    height: '20px',
    position: 'relative'
  },
  top: {
    position: 'absolute',
    top: '-2px'
  },
  bottom: {
    position: 'absolute',
    top: '5px'
  }
};

function SortIcon(props) {
  var onTopClick = function onTopClick() {
    return props.onClick('asc');
  };
  var onBottomClick = function onBottomClick() {
    return props.onClick('desc');
  };
  var topColor = props.disableAsc ? props.disabledColor : props.enabledColor;
  var bottomColor = props.disableDesc ? props.disabledColor : props.enabledColor;
  return _react2.default.createElement(
    'div',
    { style: _extends({}, styles.wrapper, props.style) },
    _react2.default.createElement(_arrowIcon2.default, {
      direction: 'top',
      onClick: onTopClick,
      style: _extends({}, styles.top, { cursor: props.disableAsc ? 'auto' : 'pointer' }),
      color: topColor
    }),
    _react2.default.createElement(_arrowIcon2.default, {
      direction: 'bottom',
      onClick: onBottomClick,
      style: _extends({}, styles.bottom, { cursor: props.disableDesc ? 'auto' : 'pointer' }),
      color: bottomColor
    })
  );
}

SortIcon.propTypes = {
  style: _react.PropTypes.object,
  onClick: _react.PropTypes.func,
  disableAsc: _react.PropTypes.bool,
  disableDesc: _react.PropTypes.bool,
  disabledColor: _react.PropTypes.string,
  enabledColor: _react.PropTypes.string
};